/*-
 * ~~~~~~licensing~~~~~~
 * events-common
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.core.events.common;

import java.util.Arrays;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

public enum SubscriptionType {

    PUSH("PUSH"),
    PULL("PULL");

    private static Map<String, SubscriptionType> map = null;
    private final String name;

    SubscriptionType(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public boolean equalsName(String checkingName) {
        return checkingName != null && this.name.equals(checkingName.toUpperCase());
    }

    public static Map<String, SubscriptionType> getEnumAsMap() {
        if (map == null) {
            map = Arrays.stream(SubscriptionType.values())
                    .collect(Collectors.toMap(SubscriptionType::getName, Function.identity()));
        }
        return map;
    }

}
